> For the complete documentation index, see [llms.txt](https://docs.console.zenlayer.com/api-reference/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.console.zenlayer.com/api-reference/zec/disk-snapshot/modifysnapshotsattribute.md).

# ModifySnapshotsAttribute

## 1. API Description

This API (ModifySnapshotsAttribute) is used to modify the attributes of the specified snapshot.

{% hint style="info" %}
**Notes**

* Batch operations are supported. Up to 100 snapshots can be operated on in each request.
* If any of the snapshot IDs does not exist, the operation fails immediately.
  {% endhint %}

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name | Required | Type            | Description                                                                                                                                                                                                                                                                                                                           |
| -------------- | -------- | --------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| snapshotIds    | Yes      | Array of String | <p>Snapshot ID list.</p><p>It can be obtained by calling <a href="/api-reference/zec/disk-snapshot/describesnapshots.md">DescribeSnapshots</a>.</p>                                                                                                                                                                                   |
| snapshotName   | No       | String          | Snapshot name.                                                                                                                                                                                                                                                                                                                        |
| retentionTime  | No       | String          | <p>Expiration time of the snapshot.</p><p>Format: yyyy-MM-ddTHH<span data-gb-custom-inline data-tag="emoji" data-code="1f1f2-1f1f2">🇲🇲</span>ssZ.</p><p>To retain it permanently, set <code>isPermanent</code>=<code>true</code>.</p><p>When this time is specified, it must be more than 24 hours later than the current time.</p> |
| isPermanent    | No       | Boolean         | Whether the snapshots created by the snapshot schedule are retained indefinitely.                                                                                                                                                                                                                                                     |

## 3. Output Parameters

| Parameter Name | Type   | Description                                                                                                           |
| -------------- | ------ | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**1. Modify the attributes of a specified snapshot: change the name and set the retention period to permanent.**

```json
POST /api/v2/zec HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: ModifySnapshotsAttribute
<Common Request Params>

Request：
{
    "snapshotIds": ["snapshotId1","snapshotId2"],
    "snapshotName": "snap_201711301143",
    "isPermanent": true
}

Response：
{
  "requestId": "T05992D0C-7E8B-4047-B0C0-780F2CD549D3",
  "response": {
    "requestId": "T05992D0C-7E8B-4047-B0C0-780F2CD549D3"
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code                          | Description              |
| ---------------- | ----------------------------------- | ------------------------ |
| 404              | INVALID\_DISK\_SNAPSHOT\_NOT\_FOUND | Snapshot does not exist. |
